function [A,AN,b] = assemble(nodes,elements,ID,IN,K,f,gN)

% [A,AN,b] = assemble(nodes,elements,ID,IN,k,f,gN)


% pocet uzlu (pocet stupnu volnosti)
n = size(nodes,2);

% pocet elementu
m = size(elements,2);

% A = zeros(n,n);
A = sparse(n,n);
AN = A;
b = zeros(n,1);

for l=1:m

    el = elements(:,l);
    
    Al = aloc_gradgrad_L1tri(nodes,el,K(l));
    bl = bloc_id_L1tri(nodes,el,f(l));
    
    nl = max(size(Al));
    
    AN(el,el) = AN(el,el) + Al;
    
    for j=1:nl
        for k=1:nl            
            if j==k | (~in(ID,el(j)) & ~in(ID,el(k)))                
                A(el(j),el(k)) = A(el(j),el(k)) + Al(j,k);
            end
        end
        if ~in(ID,el(j))
            b(el(j)) = b(el(j)) + bl(j);
        end
    end
end


mN = size(IN,2);

for l=1:mN
    
    el = IN(:,l);

    bl = bloc_idboundary_L1tri(nodes,el,gN(l));
    
    nl = max(size(bl));
    
    for j=1:nl
        if ~in(ID,el(j))
            b(el(j)) = b(el(j)) + bl(j);
        end
    end
    
end